#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sched.h>
#include <sys/mman.h>
#include <sys/types.h>

main(int argc, char **argv)
{
    int pri = 0;
    int uid = 0;
    struct sched_param par;

    if (argc > 2){
	pri = atoi(argv[1]);
	par.sched_priority = pri;

	/* set scheduling priority */
	if (sched_setscheduler(0,SCHED_FIFO,&par) != -1)
	    fprintf(stderr, "priority %d FIFO scheduling enabled.\n", pri);
	else 
	    fprintf(stderr, "can't enable FIFO scheduling. (not root?)\n");

	/* enable memory locking */
	if (mlockall(MCL_FUTURE) != -1) {
	    fprintf(stderr, "memory locking enabled.\n");
	}
	else {
	    fprintf(stderr, "can't enable memory locking. (not root?)\n");
	}

	/* lose setuid priveliges */
	uid = getuid();
	if (seteuid(uid) != -1){
	    fprintf(stderr, "set euid to %d.\n", uid);
	}
	else {
	    fprintf(stderr, "error setting euid to %d.\n", uid);
	}


	fprintf (stderr, "executing %s\n", argv[2], pri);
	execvp(argv[2], argv+2);
    }

    else{
	fprintf (stderr, "usage: %s <FIFO priority> <command> <argument list>\n", argv[0]);
    }
}
